import axios from 'axios';
import { readable, writable } from 'svelte/store';

// console.log('*** Using api.js ***');


export let delete_object = async function delete_object({api_cfg=null, endpoint='', params={}, data={}, return_meta=false, log_lvl=0}) {
    console.log('*** delete_object() ***');

    if (log_lvl) {
        // console.log(api_cfg);
        console.log(endpoint);
        console.log(params);
        if (log_lvl > 1) {
            console.log('Data:', data);
            console.log(typeof data);
        }
        // console.log(return_meta);
        // console.log(as_list);
    }

    // https://stackoverflow.com/questions/51069552/axios-delete-request-with-body-and-headers

    let axios_api = axios.create({
        baseURL: api_cfg['base_url'],
        // timeout: 2000,
        /* other custom settings */
    });
    axios_api.defaults.headers = api_cfg['headers'];

    //OLD: axios_api.delete(endpoint, { 'data': data })
    let response_data = await axios_api.delete(endpoint, { params: params, 'data': data })
    .then(function (response) {
        console.log(response.data);
        return response.data;
    })
    .catch(function (error) {
        if (error.response && error.response.status === 404) {
            return null; // Returning null since there were no results
        }
        console.log(error);
        return false; // Returning false since something may have gone wrong. Also more in line with what the API returns.
        // return error;
    });

    if (log_lvl > 1) {
        console.log(response_data);
    }
    return response_data;
}


export let temp_get_blob_percent_completed = 0;
// export let get_blob_percent_completed = readable(temp_get_blob_percent_completed);
export let get_blob_percent_completed = temp_get_blob_percent_completed;

export let temp_get_object_percent_completed = 0;
// export let get_object_percent_completed = readable(temp_get_object_percent_completed);
export let get_object_percent_completed = temp_get_object_percent_completed;

// Updated 2022-10-28
export let get_object = async function get_object({api_cfg, endpoint='', headers={}, params={}, data={}, timeout=600000, return_meta=false, return_blob=false, filename=null, auto_download=false, as_list=false, log_lvl=0}) {
    if (log_lvl) {
        console.log('*** get_object() ***');
    }

    if (log_lvl) {
        console.log(`Endpoint: ${endpoint}`);
        console.log('Params:', params);
        if (log_lvl > 1) {
            console.log('Data:', data);
            console.log(`Base URL: ${api_cfg['base_url']}`);
            console.log('API Config:', api_cfg);
        }
        if (log_lvl > 2) {
            console.log(`Return Meta: ${return_meta}`);
            console.log(`Return Blob: ${return_blob}`);
            console.log(`Filename: ${filename}`);
            console.log(`Auto Download: ${auto_download}`);
            console.log(`As List: ${as_list}`);
        }
    }

    if (!api_cfg) {
        console.log('No API Config was provided. Returning false.');
        return false;
    }

    let axios_api = axios.create({
        baseURL: api_cfg['base_url'],
        timeout: timeout, // in milliseconds; 60000 = 60 seconds
        /* other custom settings */
    });
    axios_api.defaults.headers = api_cfg['headers'];
    console.log(axios_api.defaults.headers);

    console.log('Additional headers:', headers);
    // console.log(headers);

    console.log('Clean the headers. No _underscores_!')
    let headers_cleaned = {};
    for (const prop in headers) {
        // No underscores allowed in the header parameters!
        let prop_cleaned = prop.replaceAll('_', '-');

        // The value must be a string for the header!
        if (typeof headers[prop] != 'string') {
            headers[prop] = JSON.stringify(headers[prop]);
        }

        headers_cleaned[prop_cleaned] = headers[prop];

        if (log_lvl) {
            console.log(`${prop_cleaned}: ${headers_cleaned[prop_cleaned]}`);
        }
    }
    headers = headers_cleaned;
    console.log('Cleaned additional headers:', headers);

    console.log('URL params:');
    for (const prop in params) {
        if (log_lvl) {
            console.log(`${prop}: ${params[prop]}`);
        }
        if (params[prop] === null ) {
            params[prop] = 'null';
        }
    }

    if (!return_blob) {
        // let response_data_promise = await axios_api.get(
        //         endpoint,
        //         {
        //             params: params,
        //             'paramsSerializer': params => parse_params(params),
        //             onDownloadProgress: (progressEvent) => {
        //                 let percent_completed = Math.round(
        //                     (progressEvent.loaded * 100) / progressEvent.total
        //                 );
        //                 console.log('GET Data Timestamp:', progressEvent.timeStamp, 'Total:', progressEvent.total, 'Loaded:', progressEvent.loaded, 'Percent Completed', percent_completed);

        //                 temp_get_object_percent_completed = percent_completed;
        //             }
        //         }
        //     )
        let response_data_promise = await axios_api.get(
                endpoint,
                {
                    headers: headers,
                    params: params,
                    onDownloadProgress: (progressEvent) => {
                        let percent_completed = Math.round(
                            (progressEvent.loaded * 100) / progressEvent.total
                        );
                        console.log('GET Data Timestamp:', progressEvent.timeStamp, 'Total:', progressEvent.total, 'Loaded:', progressEvent.loaded, 'Percent Completed', percent_completed);

                        temp_get_object_percent_completed = percent_completed;
                    }
                }
            )
        .then(function (response) {
            if (log_lvl) {
                console.log('GET Response:', response);
            }
            if (!Array.isArray(response.data['data']) && as_list) {
                if (log_lvl) {
                    console.log('Data result is a dictionary/object, not an array/list. Forcing return as an array/list');
                }
                let return_data = [];
                return_data.push(response.data['data']);
                return return_data;
            } else if (response.data['data']) {
                let return_data = response.data['data'];
                if (log_lvl) {
                    if (Array.isArray(return_data)) {
                        console.log(`Data result is an array/list. Array length: ${return_data.length}`);
                    } else {
                        console.log(`Data result is a dictionary/object, not an array/list.`);
                    }
                }
                return return_data;
            } else {
                let return_data = response.data;
                if (log_lvl) {
                    if (Array.isArray(return_data)) {
                        console.log(`Not a standard response from Aether's API. Data result is an array/list. Array length: ${return_data.length}`);
                    } else {
                        console.log(`Not a standard response from Aether's API. Data result is a dictionary/object, not an array/list.`);
                    }
                }
                return return_data;
            }
        })
        .catch(function (error) {
            if (log_lvl) {
                console.log(`Base URL: ${api_cfg['base_url']} | Endpoint: ${endpoint}`);
                console.log('Error Message:', error.message); // Is this needed here or below in the in the else portion???

                if (error.response) {
                    // The request was made and the server responded with a status code that falls out of the range of 2xx
                    console.log('Error Response Data', error.response.data);
                    console.log('Error Response Status', error.response.status);
                    console.log('Error Response Headers', error.response.headers);
                } else if (error.request) {
                    // The request was made but no response was received `error.request` is an instance of XMLHttpRequest in the browser and an instance of http.ClientRequest in node.js
                    console.log('Error Request', error.request);
                } else {
                    // Something happened in setting up the request that triggered an Error
                    console.log('Error Message', error.message);
                }
            }
            if (log_lvl > 1) {
                console.log('Error:', error);
                console.log(error.config);
            }

            if (error.response && error.response.status === 404) {
                if (log_lvl) {
                    console.log('The response was a 404 not found "error". Returning null.');
                }
                if (log_lvl > 1) {
                    console.log(error.response);
                }
                if (log_lvl > 2) {
                    console.log(error);
                }
                return null; // Returning null since there were no results
            }
            if (log_lvl) {
                console.log('The response was an error. Returning false.');
            }

            return false; // Returning false since something may have gone wrong. This includes timeouts. Also more in line with what the API returns.
            // return error;
        });

        if (log_lvl > 1) {
            // console.log(`Response Data: ${response_data_promise}`);
            console.log(`Response Data:`, response_data_promise);
            // console.log(response_data_promise);
        }
        if (response_data_promise) {
            // The most common and expected response.
            // console.log('Returning result. This is generally expected.');
            return response_data_promise;
        } else if (response_data_promise === null) {
            // Less common, but expected response if no results were returned.
            console.log('Returning null. This is expected if no results were found.');
            return response_data_promise;
        } else if (response_data_promise === false) {
            // Not common, but expected response if the request to the API had an issue.
            console.log('Returning false. There may have been an issue with this request.');
            return response_data_promise;
        } else {
            // This generally should not happen. It likely means the query was bad or an API issue.
            console.log('Returning unknown. This should not happen in most cases.');
            Promise.reject(new Error('fail')).then(resolved, rejected);
        }
    } else {
        // console.log('Expecting a Blob to be returned...');

        let response_data_promise = await axios_api.get(
                endpoint,
                {
                    params: params,
                    // 'paramsSerializer': params => parse_params(params),
                    responseType: 'blob',
                    onDownloadProgress: (progressEvent) => {
                        let percent_completed = Math.round(
                            (progressEvent.loaded * 100) / progressEvent.total
                        );
                        console.log('GET Blob Timestamp:', progressEvent.timeStamp, 'Total:', progressEvent.total, 'Loaded:', progressEvent.loaded, 'Percent Completed', percent_completed);

                        temp_get_blob_percent_completed = percent_completed;
                    }
                }
            )
        .then(function (response) {
            if (log_lvl) {
                console.log(response);
            }

            const { data, headers } = response
            console.log(headers);

            if (filename) {
            } else if (headers['content-disposition']) {
                filename = headers['content-disposition'].replace(/\w+;filename=(.*)/, '$1');
            } else {
                filename = 'unknown_file.ext';
            }

            if (auto_download) {
                const url = window.URL.createObjectURL(new Blob([response.data]));
                const link = document.createElement('a');
                link.href = url;
                // link.setAttribute('download', 'event_exhibit_tracking_export.xlsx'); //or any other extension
                link.setAttribute('download', filename); //or any other extension
                document.body.appendChild(link);
                link.click();
                return true;
            } else {
                return response;
            }
        });

        if (response_data_promise) {
            // The most common and expected response.
            // console.log('Returning result. This is generally expected.');
            // let test_blob = new Blob([response_data_promise.data]);
            // console.log(test_blob);
            // return test_blob;
            // console.log(response_data_promise.blob());
            return response_data_promise;
        } else {
            // This generally should not happen. It likely means the query was bad or an API issue.
            console.log('Returning unknown. This should not happen in most cases.');
            Promise.reject(new Error('fail')).then(resolved, rejected);
        }
    }
}

export let patch_object = async function patch_object({api_cfg=null, endpoint='', params={}, data={}, return_meta=false, log_lvl=0}) {
    console.log('*** patch_object() ***');

    if (log_lvl) {
        // console.log(api_cfg);
        console.log(endpoint);
        console.log(params);
        if (log_lvl > 1) {
            console.log(data);
        }
        // console.log(return_meta);
        // console.log(as_list);
    }

    let axios_api = axios.create({
        baseURL: api_cfg['base_url'],
        /* other custom settings */
    });
    axios_api.defaults.headers = api_cfg['headers'];

    let response_data = await axios_api.patch(endpoint, data, { params: params })
    .then(function (response) {
        console.log(response.data);
        return response.data['data'];
        //return response.data;
    })
    .catch(function (error) {
        if (error.response && error.response.status === 404) {
            return null; // Returning null since there were no results
        }
        console.log(error);
        return false; // Returning false since something may have gone wrong. Also more in line with what the API returns.
        // return error;
    });

    if (log_lvl > 1) {
        console.log(response_data);
    }
    return response_data;
}


// Updated 2023-11-10
export let post_object = async function post_object({api_cfg=null, endpoint='', params={}, data={}, form_data=null, return_meta=false, return_blob=false, filename=null, auto_download=false, log_lvl=0}) {
    console.log('*** post_object() ***');

    if (log_lvl) {
        // console.log(api_cfg);
        console.log('Endpoint:', endpoint);
        console.log('Params:', params);
        if (log_lvl > 1) {
            console.log('Data:', data);
            console.log(typeof data);
        }
        if (log_lvl > 2) {
            console.log(`Return Meta: ${return_meta}`);
            console.log(`Return Blob: ${return_blob}`);
            console.log(`Filename: ${filename}`);
            console.log(`Auto Download: ${auto_download}`);
        }
        // console.log(return_meta);
        // console.log(as_list);
    }

    let axios_api = axios.create({
        baseURL: api_cfg['base_url'],
        /* other custom settings */
    });
    axios_api.defaults.headers = api_cfg['headers'];
    console.log('Axios API', axios_api);
    // console.log('Axios API POST', axios_api.post);

    // if (typeof data == 'FormData') {
    if (form_data) {
        axios_api.defaults.headers['content-type'] = 'multipart/form-data';
        data = form_data;
    } else {
        axios_api.defaults.headers['content-type'] = 'application/json';
    }


    if (!return_blob) {
        let response_data = await axios_api.post(endpoint, data, { params: params })
        .then(function (response) {
            console.log('POST Response Data:', response.data);
            if (response.data['data'].result === null) {
                // This should mean that the request was successful, but a result of None/null was returned from Aether API.
                // console.log('Returning null after POST');
                return null;
            } else {
                // This should mean that the request was successful, and a result with data was returned from Aether API.
                // console.log('Returning data after POST');
                return response.data['data'];
            }
            //return response.data;
        })
        .catch(function (error) {
            if (error.response && error.response.status === 404) {
                return null; // Returning null since there were no results
            }
            console.log(error);
            return false; // Returning false since something may have gone wrong. Also more in line with what the API returns.
            // return error;
        });

        if (log_lvl > 1) {
            console.log('Response Data:', response_data);
        }
        axios_api.defaults.headers['content-type'] = 'application/json';
        return response_data;

    } else {
        // console.log('Expecting a Blob to be returned...');

        let response_data_promise = await axios_api.post(
                endpoint,
                data,
                {
                    params: params,
                    responseType: 'blob',
                    onDownloadProgress: (progressEvent) => {
                        let percent_completed = Math.round(
                            (progressEvent.loaded * 100) / progressEvent.total
                        );
                        console.log('POST Blob Timestamp:', progressEvent.timeStamp, 'Total:', progressEvent.total, 'Loaded:', progressEvent.loaded, 'Percent Completed', percent_completed);

                        temp_get_blob_percent_completed = percent_completed;
                    }
                }
            )
        .then(function (response) {
            if (log_lvl) {
                console.log(response);
            }

            const { data, headers } = response
            console.log(headers);

            if (filename) {
            } else if (headers['content-disposition']) {
                filename = headers['content-disposition'].replace(/\w+;filename=(.*)/, '$1');
            } else {
                filename = 'unknown_file.ext';
            }

            if (auto_download) {
                const url = window.URL.createObjectURL(new Blob([response.data]));
                const link = document.createElement('a');
                link.href = url;
                // link.setAttribute('download', 'event_exhibit_tracking_export.xlsx'); //or any other extension
                link.setAttribute('download', filename); //or any other extension
                document.body.appendChild(link);
                link.click();
                return true;
            } else {
                return response;
            }
        });

        if (response_data_promise) {
            // The most common and expected response.
            // console.log('Returning result. This is generally expected.');
            // let test_blob = new Blob([response_data_promise.data]);
            // console.log(test_blob);
            // return test_blob;
            // console.log(response_data_promise.blob());
            return response_data_promise;
        } else {
            // This generally should not happen. It likely means the query was bad or an API issue.
            console.log('Returning unknown. This should not happen in most cases.');
            Promise.reject(new Error('fail')).then(resolved, rejected);
        }
    }
}


// Updated 2023-12-01
export let get_ae_obj_id_crud = async function get_ae_obj_id_crud({
        api_cfg,
        no_account_id=false,
        obj_type,
        obj_id,
        use_alt_table=false,
        use_alt_base=false,
        inc={},
        enabled='enabled',
        hidden='not_hidden',
        limit=999999,
        offset=0,
        data={},
        // key,
        jwt=null,
        headers={},
        params={},
        return_meta=false,
        log_lvl=0}) {
    if (log_lvl) {
        console.log('*** get_ae_obj_id_crud() ***');
    }

    // data = {};
    // data['super_key'] = key;
    // data['jwt'] = jwt;
    // NOTE: The key and or JWT should be in the header of the DELETE, GET, PATCH, POST

    let endpoint = '';
    if (obj_type == 'account') {
        endpoint = `/crud/account/${obj_id}`;
    } else if (obj_type == 'address') {
        endpoint = `/crud/address/${obj_id}`;
    } else if (obj_type == 'archive') {
        endpoint = `/crud/archive/${obj_id}`;
    } else if (obj_type == 'archive_content') {
        endpoint = `/crud/archive/content/${obj_id}`;
    } else if (obj_type == 'contact') {
        endpoint = `/crud/contact/${obj_id}`;
    } else if (obj_type == 'data_store') {
        endpoint = `/crud/data_store/${obj_id}`;
    } else if (obj_type == 'event') {
        endpoint = `/crud/event/${obj_id}`;
    } else if (obj_type == 'event_abstract') {
        endpoint = `/crud/event/abstract/${obj_id}`;
    } else if (obj_type == 'event_badge') {
        endpoint = `/crud/event/badge/${obj_id}`;
    } else if (obj_type == 'event_device') {
        endpoint = `/crud/event/device/${obj_id}`;
    } else if (obj_type == 'event_exhibit') {
        endpoint = `/crud/event/exhibit/${obj_id}`;
    } else if (obj_type == 'event_file') {
        endpoint = `/crud/event/file/${obj_id}`;
    } else if (obj_type == 'event_location') {
        endpoint = `/crud/event/location/${obj_id}`;
    } else if (obj_type == 'event_person') {
        endpoint = `/crud/event/person/${obj_id}`;
    } else if (obj_type == 'event_presentation') {
        endpoint = `/crud/event/presentation/${obj_id}`;
    } else if (obj_type == 'event_presenter') {
        endpoint = `/crud/event/presenter/${obj_id}`;
    } else if (obj_type == 'event_session') {
        endpoint = `/crud/event/session/${obj_id}`;
    } else if (obj_type == 'event_track') {
        endpoint = `/crud/event/track/${obj_id}`;
    } else if (obj_type == 'grant') {
        endpoint = `/crud/grant/${obj_id}`;
    } else if (obj_type == 'hosted_file') {
        endpoint = `/crud/hosted_file/${obj_id}`;
    } else if (obj_type == 'journal') {
        endpoint = `/crud/journal/${obj_id}`;
    } else if (obj_type == 'journal_entry') {
        endpoint = `/crud/journal/entry/${obj_id}`;
    } else if (obj_type == 'order') {
        endpoint = `/crud/order/${obj_id}`;
    } else if (obj_type == 'order_line') {
        endpoint = `/crud/order/line/${obj_id}`;
    } else if (obj_type == 'page') {
        endpoint = `/crud/page/${obj_id}`;
    } else if (obj_type == 'person') {
        endpoint = `/crud/person/${obj_id}`;
    } else if (obj_type == 'post') {
        endpoint = `/crud/post/${obj_id}`;
    } else if (obj_type == 'post_comment') {
        endpoint = `/crud/post/comment/${obj_id}`;
    } else if (obj_type == 'site') {
        endpoint = `/crud/site/${obj_id}`;
    } else if (obj_type == 'site_domain') {
        endpoint = `/crud/site/domain/${obj_id}`;
    } else if (obj_type == 'sponsorship_cfg') {
        endpoint = `/crud/sponsorship/cfg/${obj_id}`;
    } else if (obj_type == 'sponsorship') {
        endpoint = `/crud/sponsorship/${obj_id}`;
    // } else if (obj_type == 'user') {
    //     endpoint = `/crud/user/${obj_id}`;
    } else {
        console.log(`Unknown object type: ${obj_type}`);
        return false;
    }
    if (log_lvl) {
        console.log('Endpoint:', endpoint);
    }

    params['use_alt_table'] = use_alt_table;
    params['use_alt_base'] = use_alt_base;

    if (log_lvl) {
        console.log('Params:', params);
    }

    if (no_account_id) {
        headers['x-no-account-id'] = 'Nothing to See Here';
        // params['x_no_account_id_token'] = 'Nothing to See Here';
        // headers['x-account-id'] = null;
        // headers['x-no-account-id-token'] = 'Nothing to See Here'; // get_object() will fix the underscores to dashes
    }

    let object_obj_get_promise = await get_object({
        api_cfg: api_cfg,
        endpoint: endpoint,
        headers: headers,
        params: params,
        log_lvl: log_lvl
        });

    if (log_lvl > 1) {
        console.log(object_obj_get_promise);
    }

    return object_obj_get_promise;
}


// Updated 2023-11-15
export let get_ae_obj_li_for_obj_id_crud = async function get_ae_obj_li_for_obj_id_crud({
        api_cfg,
        obj_type,
        for_obj_type,
        for_obj_id=null, // NOTE: Changed 2023-12-06 to no longer required
        use_alt_table=false,
        use_alt_base=false,
        inc={},
        enabled='enabled',
        hidden='not_hidden',
        order_by_li=null,
        limit=999999,
        offset=0,
        key,
        jwt=null,
        headers={},
        params_json=null, // NOTE: This is a JSON object that needs to be safely converted to a string for the params. This is used for the API endpoint. Example: { "fulltext_search": { "default_qry_str": "Search string for default", "address_default_qry_str": "Search string for address", "contact_1_default_qry_str": "Search string for contact_1" } }
        // json_obj=null, // NOTE: This is a JSON object that needs to be safely converted to a string for the params. This is used for the search endpoint.
        params={},
        return_meta=false,
        log_lvl=0
        }) {
    if (log_lvl) {
        console.log('*** get_ae_obj_li_for_obj_id_crud() ***');
    }

    // data = {};
    // data['super_key'] = key;
    // data['jwt'] = jwt;
    // NOTE: The key and or JWT should be in the header of the DELETE, GET, PATCH, POST

    // const endpoint = `/crud/${obj_type}/list`;

    let endpoint = '';
    if (obj_type == 'account') {
        endpoint = `/crud/account/list`;
    } else if (obj_type == 'address') {
        endpoint = `/crud/address/list`;
    } else if (obj_type == 'archive') {
        endpoint = `/crud/archive/list`;
    } else if (obj_type == 'archive_content') {
        endpoint = `/crud/archive/content/list`;
    } else if (obj_type == 'contact') {
        endpoint = `/crud/contact/list`;
    } else if (obj_type == 'data_store') {
        endpoint = `/crud/data_store/list`;
    } else if (obj_type == 'event') {
        endpoint = `/crud/event/list`;
    } else if (obj_type == 'event_abstract') {
        endpoint = `/crud/event/abstract/list`;
    } else if (obj_type == 'event_badge') {
        endpoint = `/crud/event/badge/list`;
    } else if (obj_type == 'event_device') {
        endpoint = `/crud/event/device/list`;
    } else if (obj_type == 'event_exhibit') {
        endpoint = `/crud/event/exhibit/list`;
    } else if (obj_type == 'event_file') {
        endpoint = `/crud/event/file/list`;
    } else if (obj_type == 'event_location') {
        endpoint = `/crud/event/location/list`;
    } else if (obj_type == 'event_person') {
        endpoint = `/crud/event/person/list`;
    } else if (obj_type == 'event_presentation') {
        endpoint = `/crud/event/presentation/list`;
    } else if (obj_type == 'event_presenter') {
        endpoint = `/crud/event/presenter/list`;
    } else if (obj_type == 'event_session') {
        endpoint = `/crud/event/session/list`;
    } else if (obj_type == 'event_track') {
        endpoint = `/crud/event/track/list`;
    } else if (obj_type == 'grant') {
        endpoint = `/crud/grant/list`;
    } else if (obj_type == 'hosted_file') {
        endpoint = `/crud/hosted_file/list`;
    } else if (obj_type == 'journal') {
        endpoint = `/crud/journal/list`;
    } else if (obj_type == 'journal_entry') {
        endpoint = `/crud/journal/entry/list`;
    } else if (obj_type == 'order') {
        endpoint = `/crud/order/list`;
    } else if (obj_type == 'order_line') {
        endpoint = `/crud/order/line/list`;
    } else if (obj_type == 'page') {
        endpoint = `/crud/page/list`;
    } else if (obj_type == 'person') {
        endpoint = `/crud/person/list`;
    } else if (obj_type == 'post') {
        endpoint = `/crud/post/list`;
    } else if (obj_type == 'post_comment') {
        endpoint = `/crud/post/comment/list`;
    } else if (obj_type == 'site') {
        endpoint = `/crud/site/list`;
    } else if (obj_type == 'sponsorship_cfg') {
        endpoint = `/crud/sponsorship/cfg/list`;
    } else if (obj_type == 'sponsorship') {
        endpoint = `/crud/sponsorship/list`;
    // } else if (obj_type == 'user') {
    //     endpoint = `/crud/user/list`;
    } else if (obj_type == 'lu' && for_obj_type == 'country_subdivision') {
        endpoint = `/crud/lu/country_subdivision/list`;
        for_obj_type = null;
    } else if (obj_type == 'lu' && for_obj_type == 'country') {
        endpoint = `/crud/lu/country/list`;
        for_obj_type = null;
    } else if (obj_type == 'lu' && for_obj_type == 'time_zone') {
        endpoint = `/crud/lu/time_zone/list`;
        for_obj_type = null;
    } else {
        console.log(`Unknown object type: ${obj_type}`);
        return false;
    }
    if (log_lvl) {
        console.log('Endpoint:', endpoint);
    }

    if (for_obj_type) {
        params['for_obj_type'] = for_obj_type;
    }
    if (for_obj_id) {
        params['for_obj_id'] = for_obj_id;
    }

    params['use_alt_table'] = use_alt_table;
    params['use_alt_base'] = use_alt_base;

    /* Need to deal with inc params here */

    let allowed_enabled_list = ['all', 'enabled', 'not_enabled']
    if (allowed_enabled_list.includes(enabled) ) {
        params['enabled'] = enabled;
    }

    let allowed_hidden_list = ['all', 'hidden', 'not_hidden'];
    if (allowed_hidden_list.includes(hidden) ) {
        params['hidden'] = hidden;
    }

    // NOTE: The order_by_li variable is in the "headers" because if is a the URL GET params do not handle multiple values very well. Maybe base64 encore in the future or something? Reminder that GET requests should not have a body (no JSON).
    // NOTE: The order_by_li should be a key value pair of the property/DB field to sort and how to sort (ASC or DESC)
    if (order_by_li) {
        headers['order_by_li'] = order_by_li;
    }

    if (limit >= 0) {
        params['limit'] = limit;
    }

    if (offset >= 0) {
        params['offset'] = offset;
    }

    if (params_json) {
        // NOTE: This is a JSON object that needs to be safely converted to a string for the params. This is used for the search endpoint.
        // Max characters for a GET request is 2083. This is a limitation of the browser (Microsoft IE and Edge).
        console.log('JSON Object:', params_json);
        // NOTE: "jp" stands for "JSON Params"
        params['jp'] = encodeURIComponent(JSON.stringify(params_json));
        if (params['jp'].length > 2083) {
            console.log(`The JSON object is too large to be used as a GET parameter. The overall max URL length is 2083 characters. Please use the POST endpoint instead. Length = ${params['jp'].length} [THIS DOES NOT EXIST YET]`);
            return false;
        }
    }

    // if (json_obj) {
    //     // NOTE: This is a JSON object that needs to be safely converted to a string for the params. This is used for the search endpoint.
    //     // Max characters for a GET request is 2083. This is a limitation of the browser (Microsoft IE and Edge).
    //     console.log('JSON Object:', json_obj);
    //     params['json_str'] = encodeURIComponent(JSON.stringify(json_obj));
    //     if (params['json_str'].length > 2083) {
    //         console.log(`The JSON object is too large to be used as a GET parameter. The overall max URL length is 2083 characters. Please use the POST endpoint instead. Length = ${params['json_str'].length} [THIS DOES NOT EXIST YET]`);
    //         return false;
    //     }
    // }

    if (log_lvl) {
        console.log('Params:', params);
    }

    let object_li_get_promise = await api.get_object({
        api_cfg: api_cfg,
        endpoint: endpoint,
        headers: headers,
        params: params,
        return_meta: return_meta,
        log_lvl: log_lvl
        });

    if (log_lvl > 1) {
        console.log(object_li_get_promise);
    }

    return object_li_get_promise;
}


// Updated 2023-07-24
export let create_ae_obj_crud = async function create_ae_obj_crud({api_cfg, obj_type, field_name=null, field_value=null, fields={}, key, jwt=null, headers={}, params={}, data={}, return_obj=false, obj_v_name='', return_meta=false, log_lvl=0}) {
    if (log_lvl) {
        console.log('*** create_ae_obj_crud() ***');
    }

    data['super_key'] = key;
    data['jwt'] = jwt;
    // NOTE: The key and or JWT should be in the header of the DELETE, GET, PATCH, POST

    // This obj_v_name is the view name to use when returning data. Do not prefix it with v_. This is checked and done automatically by the API.
    // This is not currently being exposed to other areas of the code. It is only used here. For now?
    if (obj_v_name) {
        obj_v_name = '';
    }

    let endpoint = '';
    if (obj_type == 'account') {
        endpoint = `/crud/account`;
    } else if (obj_type == 'address') {
        endpoint = `/crud/address`;
    } else if (obj_type == 'archive') {
        endpoint = `/crud/archive`;
    } else if (obj_type == 'archive_content') {
        endpoint = `/crud/archive/content`;
    } else if (obj_type == 'contact') {
        endpoint = `/crud/contact`;
    } else if (obj_type == 'data_store') {
        endpoint = `/crud/data_store`;
    } else if (obj_type == 'event') {
        endpoint = `/crud/event`;
    } else if (obj_type == 'event_abstract') {
        endpoint = `/crud/event/abstract`;
    } else if (obj_type == 'event_badge') {
        endpoint = `/crud/event/badge`;
    } else if (obj_type == 'event_device') {
        endpoint = `/crud/event/device`;
    } else if (obj_type == 'event_exhibit') {
        endpoint = `/crud/event/exhibit`;
    } else if (obj_type == 'event_file') {
        endpoint = `/crud/event/file`;
    } else if (obj_type == 'event_location') {
        endpoint = `/crud/event/location`;
    } else if (obj_type == 'event_person') {
        endpoint = `/crud/event/person`;
    } else if (obj_type == 'event_presentation') {
        endpoint = `/crud/event/presentation`;
    } else if (obj_type == 'event_presenter') {
        endpoint = `/crud/event/presenter`;
        // obj_v_name = 'event_presenter_soft_links';
    } else if (obj_type == 'event_session') {
        endpoint = `/crud/event/session`;
    } else if (obj_type == 'event_track') {
        endpoint = `/crud/event/track`;
    } else if (obj_type == 'grant') {
        endpoint = `/crud/grant`;
    } else if (obj_type == 'hosted_file') {
        endpoint = `/crud/hosted_file`;
    } else if (obj_type == 'journal') {
        endpoint = `/crud/journal`;
    } else if (obj_type == 'journal_entry') {
        endpoint = `/crud/journal/entry`;
    } else if (obj_type == 'order') {
        endpoint = `/crud/order`;
    } else if (obj_type == 'order_line') {
        endpoint = `/crud/order/line`;
    } else if (obj_type == 'page') {
        endpoint = `/crud/page`;
    } else if (obj_type == 'person') {
        endpoint = `/crud/person`;
    } else if (obj_type == 'post') {
        endpoint = `/crud/post`;
    } else if (obj_type == 'post_comment') {
        endpoint = `/crud/post/comment`;
    } else if (obj_type == 'sponsorship_cfg') {
        endpoint = `/crud/sponsorship/cfg`;
    } else if (obj_type == 'sponsorship') {
        endpoint = `/crud/sponsorship`;
    } else if (obj_type == 'site') {
        endpoint = `/crud/site`;
    // } else if (obj_type == 'user') {
    //     endpoint = `/crud/user`;
    } else {
        console.log(`Unknown object type: ${obj_type}`);
        return false;
    }
    if (log_lvl) {
        console.log('Endpoint:', endpoint);
    }

    if (return_obj) {
        params['return_obj'] = true;

        // Pass along the view name to use for returning data.
        if (obj_v_name) {
            params['obj_v_name'] = obj_v_name;
        }
    } else {
        params['return_obj'] = false; // NOTE: This is needed because the current default on the API is to return the object.
    }

    if (field_name) {
        data['data_list'] = {}; // Really an object/dict
        data['data_list'][field_name] = field_value;
        // data['data_list']['testing'] = 'asdf 1234';
    } else if (fields) {
        data['data_list'] = fields; // Really an object/dict
    }

    // NOTE: The data object may contain objects that need to be converted to JSON strings. This is done by adding "_json" to the end of the property name. This is done because the API does not support nested objects. This is a limitation of the API.
    if (data['data_list']) {
        if (log_lvl > 1) {
            console.log('Data List:', data['data_list']);
        }
        for (const [key, value] of Object.entries(data['data_list'])) {
            // console.log(key, value);
            if (key.endsWith('_json')) {
                if (log_lvl) {
                    console.log(`${key}: ${value}`);
                }
                data['data_list'][key] = JSON.stringify(value);
            }
        }
    }

    if (log_lvl) {
        console.log('Data:', data);
    }
    // params['xxxxx run_safety_check xxxxx'] = false;
    params['by_alias'] = false;

    if (log_lvl) {
        console.log('Params:', params);
    }

    let object_obj_post_promise = await post_object({api_cfg: api_cfg, endpoint: endpoint, params: params, data: data, log_lvl: log_lvl});

    if (log_lvl > 1) {
        console.log(object_obj_post_promise);
    }

    return object_obj_post_promise;
}


// Updated 2023-06-28
export let update_ae_obj_id_crud = async function update_ae_obj_id_crud({api_cfg, obj_type, obj_id, field_name, field_value, fields={}, key, jwt=null, headers={}, params={}, data={}, return_obj=false, obj_v_name='', return_meta=false, log_lvl=0}) {
    if (log_lvl) {
        console.log('*** update_ae_obj_id_crud() ***');
    }

    data['super_key'] = key;
    data['jwt'] = jwt;
    // NOTE: The key and or JWT should be in the header of the DELETE, GET, PATCH, POST

    // This obj_v_name is the view name to use when returning data. Do not prefix it with v_. This is checked and done automatically by the API.
    // This is not currently being exposed to other areas of the code. It is only used here. For now?
    if (obj_v_name) {
        obj_v_name = '';
    }

    let endpoint = '';
    if (obj_type == 'account') {
        endpoint = `/crud/account/${obj_id}`;
    } else if (obj_type == 'address') {
        endpoint = `/crud/address/${obj_id}`;
    } else if (obj_type == 'archive') {
        endpoint = `/crud/archive/${obj_id}`;
    } else if (obj_type == 'archive_content') {
        endpoint = `/crud/archive/content/${obj_id}`;
    } else if (obj_type == 'contact') {
        endpoint = `/crud/contact/${obj_id}`;
    } else if (obj_type == 'data_store') {
        endpoint = `/crud/data_store/${obj_id}`;
    } else if (obj_type == 'event') {
        endpoint = `/crud/event/${obj_id}`;
    } else if (obj_type == 'event_abstract') {
        endpoint = `/crud/event/abstract/${obj_id}`;
    } else if (obj_type == 'event_badge') {
        endpoint = `/crud/event/badge/${obj_id}`;
    } else if (obj_type == 'event_device') {
        endpoint = `/crud/event/device/${obj_id}`;
    } else if (obj_type == 'event_exhibit') {
        endpoint = `/crud/event/exhibit/${obj_id}`;
    } else if (obj_type == 'event_file') {
        endpoint = `/crud/event/file/${obj_id}`;
    } else if (obj_type == 'event_location') {
        endpoint = `/crud/event/location/${obj_id}`;
    } else if (obj_type == 'event_person') {
        endpoint = `/crud/event/person/${obj_id}`;
    } else if (obj_type == 'event_presentation') {
        endpoint = `/crud/event/presentation/${obj_id}`;
    } else if (obj_type == 'event_presenter') {
        endpoint = `/crud/event/presenter/${obj_id}`;
        // obj_v_name = 'event_presenter_soft_links';
    } else if (obj_type == 'event_session') {
        endpoint = `/crud/event/session/${obj_id}`;
    } else if (obj_type == 'event_track') {
        endpoint = `/crud/event/track/${obj_id}`;
    } else if (obj_type == 'grant') {
        endpoint = `/crud/grant/${obj_id}`;
    } else if (obj_type == 'hosted_file') {
        endpoint = `/crud/hosted_file/${obj_id}`;
    } else if (obj_type == 'journal') {
        endpoint = `/crud/journal/${obj_id}`;
    } else if (obj_type == 'journal_entry') {
        endpoint = `/crud/journal/entry/${obj_id}`;
    } else if (obj_type == 'order') {
        endpoint = `/crud/order/${obj_id}`;
    } else if (obj_type == 'order_line') {
        endpoint = `/crud/order/line/${obj_id}`;
    } else if (obj_type == 'page') {
        endpoint = `/crud/page/${obj_id}`;
    } else if (obj_type == 'person') {
        endpoint = `/crud/person/${obj_id}`;
    } else if (obj_type == 'post') {
        endpoint = `/crud/post/${obj_id}`;
    } else if (obj_type == 'post_comment') {
        endpoint = `/crud/post/comment/${obj_id}`;
    } else if (obj_type == 'site') {
        endpoint = `/crud/site/${obj_id}`;
    } else if (obj_type == 'sponsorship_cfg') {
        endpoint = `/crud/sponsorship/cfg/${obj_id}`;
    } else if (obj_type == 'sponsorship') {
        endpoint = `/crud/sponsorship/${obj_id}`;
    // } else if (obj_type == 'user') {
    //     endpoint = `/crud/user/${obj_id}`;
    } else {
        console.log(`Unknown object type: ${obj_type}`);
        return false;
    }
    if (log_lvl) {
        console.log('Endpoint:', endpoint);
    }

    if (return_obj) {
        params['return_obj'] = true;

        // Pass along the view name to use for returning data.
        if (obj_v_name) {
            params['obj_v_name'] = obj_v_name;
        }
    } else {
        params['return_obj'] = false; // NOTE: This is needed because the current default on the API is to return the object.
    }

    if (field_name) {
        data['data_list'] = {}; // Really an object/dict
        data['data_list'][field_name] = field_value;
        // data['data_list']['testing'] = 'asdf 1234';
    } else if (fields) {
        data['data_list'] = fields; // Really an object/dict
    }

    // NOTE: The data object may contain objects that need to be converted to JSON strings. This is done by adding "_json" to the end of the property name. This is done because the API does not support nested objects. This is a limitation of the API.
    if (data['data_list']) {
        if (log_lvl > 1) {
            console.log('Data List:', data['data_list']);
        }
        for (const [key, value] of Object.entries(data['data_list'])) {
            // console.log(key, value);
            if (key.endsWith('_json')) {
                if (log_lvl) {
                    console.log(`${key}: ${value}`);
                }
                data['data_list'][key] = JSON.stringify(value);
            }
        }
    }

    // If the data is an object then we need to loop through the object and convert any objects to JSON strings, but only if the property name ends with "_json".
    // if (Array.isArray(data)) {
    //     // console.log('Data is an array');
    //     for (let i = 0; i < data.length; i++) {
    //         // console.log(data[i]);
    //         if (typeof data[i] == 'object') {
    //             // console.log('Data is an object');
    //             for (const [key, value] of Object.entries(data[i])) {
    //                 // console.log(key, value);
    //                 if (key.endsWith('_json')) {
    //                     console.log(`${key}: ${value}`);
    //                     data[i][key] = JSON.stringify(value);
    //                 }
    //             }

    //         }
    //     }
    // } else if (typeof data == 'object') {
    //     // console.log('Data is an object');
    //     for (const [key, value] of Object.entries(data)) {
    //         // console.log(key, value);
    //         if (key.endsWith('_json')) {
    //             console.log(`${key}: ${value}`);
    //             data[key] = JSON.stringify(value);
    //         }
    //     }
    // }

    if (log_lvl) {
        console.log('Data:', data);
    }
    // params['xxxxx run_safety_check xxxxx'] = false;
    params['by_alias'] = false;

    if (log_lvl) {
        console.log('Params:', params);
    }

    let object_obj_patch_promise = await patch_object({api_cfg: api_cfg, endpoint: endpoint, params: params, data: data, log_lvl: log_lvl});

    if (log_lvl > 1) {
        console.log(object_obj_patch_promise);
    }

    return object_obj_patch_promise;
}


// Updated 2023-11-14
export let delete_ae_obj_id_crud = async function delete_ae_obj_id_crud({api_cfg, obj_type, obj_id, field_name, field_value, fields={}, key, jwt=null, headers={}, params={}, data={}, method='delete', return_meta=false, log_lvl=0}) {
    if (log_lvl) {
        console.log('*** delete_ae_obj_id_crud() ***');
    }

    data['super_key'] = key;
    data['jwt'] = jwt;
    // NOTE: The key and or JWT should be in the header of the DELETE, GET, PATCH, POST

    let endpoint = '';
    if (obj_type == 'account') {
        endpoint = `/crud/account/${obj_id}`;
    } else if (obj_type == 'address') {
        endpoint = `/crud/address/${obj_id}`;
    } else if (obj_type == 'archive') {
        endpoint = `/crud/archive/${obj_id}`;
    } else if (obj_type == 'archive_content') {
        endpoint = `/crud/archive/content/${obj_id}`;
    } else if (obj_type == 'contact') {
        endpoint = `/crud/contact/${obj_id}`;
    } else if (obj_type == 'data_store') {
        endpoint = `/crud/data_store/${obj_id}`;
    } else if (obj_type == 'event') {
        endpoint = `/crud/event/${obj_id}`;
    } else if (obj_type == 'event_abstract') {
        endpoint = `/crud/event/abstract/${obj_id}`;
    } else if (obj_type == 'event_badge') {
        endpoint = `/crud/event/badge/${obj_id}`;
    } else if (obj_type == 'event_device') {
        endpoint = `/crud/event/device/${obj_id}`;
    } else if (obj_type == 'event_exhibit') {
        endpoint = `/crud/event/exhibit/${obj_id}`;
    } else if (obj_type == 'event_file') {
        endpoint = `/crud/event/file/${obj_id}`;
    } else if (obj_type == 'event_location') {
        endpoint = `/crud/event/location/${obj_id}`;
    } else if (obj_type == 'event_person') {
        endpoint = `/crud/event/person/${obj_id}`;
    } else if (obj_type == 'event_presentation') {
        endpoint = `/crud/event/presentation/${obj_id}`;
    } else if (obj_type == 'event_presenter') {
        endpoint = `/crud/event/presenter/${obj_id}`;
    } else if (obj_type == 'event_session') {
        endpoint = `/crud/event/session/${obj_id}`;
    } else if (obj_type == 'event_track') {
        endpoint = `/crud/event/track/${obj_id}`;
    } else if (obj_type == 'grant') {
        endpoint = `/crud/grant/${obj_id}`;
    } else if (obj_type == 'hosted_file') {
        endpoint = `/crud/hosted_file/${obj_id}`;
    } else if (obj_type == 'journal') {
        endpoint = `/crud/journal/${obj_id}`;
    } else if (obj_type == 'journal_entry') {
        endpoint = `/crud/journal/entry/${obj_id}`;
    } else if (obj_type == 'order') {
        endpoint = `/crud/order/${obj_id}`;
    } else if (obj_type == 'order_line') {
        endpoint = `/crud/order/line/${obj_id}`;
    } else if (obj_type == 'page') {
        endpoint = `/crud/page/${obj_id}`;
    } else if (obj_type == 'person') {
        endpoint = `/crud/person/${obj_id}`;
    } else if (obj_type == 'post') {
        endpoint = `/crud/post/${obj_id}`;
    } else if (obj_type == 'post_comment') {
        endpoint = `/crud/post/comment/${obj_id}`;
    } else if (obj_type == 'site') {
        endpoint = `/crud/site/${obj_id}`;
    } else if (obj_type == 'sponsorship_cfg') {
        endpoint = `/crud/sponsorship/cfg/${obj_id}`;
    } else if (obj_type == 'sponsorship') {
        endpoint = `/crud/sponsorship/${obj_id}`;
    // } else if (obj_type == 'user') {
    //     endpoint = `/crud/user/${obj_id}`;
    } else {
        console.log(`Unknown object type: ${obj_type}`);
        return false;
    }
    if (log_lvl) {
        console.log('Endpoint:', endpoint);
    }

    if (method) { // NOTE: method options: 'delete', 'disable', 'hide'
        params['method'] = method;
    }

    if (log_lvl) {
        console.log('Params:', params);
    }

    let object_obj_delete_promise = await delete_object({api_cfg: api_cfg, endpoint: endpoint, params: params, data: data, log_lvl: log_lvl});

    if (log_lvl > 1) {
        console.log(object_obj_delete_promise);
    }

    return object_obj_delete_promise;
}


/* BEGIN: Hosted File Related */

// Updated 2023-08-17
export let download_hosted_file = async function download_hosted_file({
        api_cfg,
        hosted_file_id,
        return_file=true,
        filename=null,
        auto_download=false,
        params={},
        log_lvl=0
        }) {
    console.log('*** stores_hosted_api.js: download_hosted_file() ***');

    const endpoint = `/hosted_file/${hosted_file_id}/download`;
    if (filename) {
        params['filename'] = filename;
    }
    params['return_file'] = true;

    let hosted_file_download_get_promise = await api.get_object({api_cfg: api_cfg, endpoint: endpoint, params: params, return_blob: true, filename: filename, auto_download: auto_download, log_lvl: log_lvl});
    // console.log(hosted_file_download_get_promise);
    return hosted_file_download_get_promise;
}

// Updated 2023-12-15
export let delete_hosted_file = async function delete_hosted_file({api_cfg, hosted_file_id, link_to_type=null, link_to_id=null, rm_orphan=false, params={}, data={}, log_lvl=1}) {
    console.log('*** stores_hosted_api.js: delete_hosted_file() ***');

    const endpoint = `/hosted_file/${hosted_file_id}`;
    if (link_to_type) {
        params['link_to_type'] = link_to_type;
    }
    if (link_to_id) {
        params['link_to_id'] = link_to_id;
    }
    if (rm_orphan) {
        params['rm_orphan'] = rm_orphan;
    }

    let hosted_file_obj_delete_promise = await api.delete_object({api_cfg: api_cfg, endpoint: endpoint, params: params, data: data, log_lvl: log_lvl});
    // console.log(hosted_file_obj_delete_promise);
    return hosted_file_obj_delete_promise;
}
/* END: Hosted File Related */


/* BEGIN: Data Store Related */

// Updated 2023-06-29
export let get_data_store_obj_w_code = async function get_data_store_obj_w_code({
        api_cfg,
        data_store_code,
        data_type='text',
        headers={},
        params={},
        log_lvl=0
        }) {
    if (log_lvl) {
        console.log('*** get_data_store_obj_w_code() ***');
    }

    // let get_item_result = window.localStorage.getItem(code);

    const endpoint = `/data_store/code/${data_store_code}`;
    let data_store_obj_get_promise = await api.get_object({api_cfg: api_cfg, endpoint: endpoint, headers: headers, params: params, log_lvl: log_lvl});

    if (data_store_obj_get_promise === false) {
        console.log('Data Store - RUN AGAIN WITH BACKUP');
        let original_api_base_url = api_cfg['base_url'];

        let temp_api = api_cfg;
        temp_api['base_url'] = temp_api['base_url_backup']

        data_store_obj_get_promise = await api.get_object({api_cfg: temp_api, endpoint: endpoint, headers: headers, params: params, log_lvl: log_lvl});
        temp_api['base_url'] = original_api_base_url;
    }

    let data_store_obj = data_store_obj_get_promise;

    if (data_type == 'text') {
        // console.log(data_store_obj.text);
        // window.localStorage.setItem(data_store_code, data_store_obj.text);
        // localStorage.setItem(data_store_code, data_store_obj.text);
    } else if (data_type == 'json') {
        // console.log(data_store_obj.json);
        // window.localStorage.setItem(data_store_code, JSON.stringify(data_store_obj.json));
        // localStorage.setItem(data_store_code, JSON.stringify(data_store_obj.json));
    }

    if (log_lvl > 1) {
        console.log('Response Data:', data_store_obj);
    }
    return data_store_obj;
}
/* END: Data Store Related */


/* BEGIN: Utility: Email Related */

// Updated 2023-06-29
export let send_email = async function send_email({api_cfg, from_email, from_name='', to_email, to_name='', cc_email=null, cc_name=null, bcc_email=null, bcc_name=null, subject, body_html, body_text=null, headers={}, params={}, data={}, return_obj=false, return_meta=false, log_lvl=0}) {
    console.log('*** send_email() ***');

    let endpoint = `/util/email/send`;

    data['from_email'] = from_email; // Required
    data['from_name'] = from_name;

    data['to_email'] = to_email; // Required
    data['to_name'] = to_name;

    data['cc_email'] = cc_email;
    data['cc_name'] = cc_name;

    data['bcc_email'] = bcc_email;
    data['bcc_name'] = bcc_name;

    data['subject'] = subject;
    if (log_lvl) {
        console.log('Data:', data);
    }

    data['body_html'] = body_html;

    data['body_text'] = body_text;

    if (return_obj) {
        params['return_obj'] = true;
    }

    let send_email_post_promise = await api.post_object({api_cfg: api_cfg, endpoint: endpoint, headers: headers, params: params, data: data, return_meta: return_meta, log_lvl: log_lvl});

    if (log_lvl > 1) {
        console.log('Response Data:', send_email_post_promise);
    }
    if (return_obj) {
        return send_email_post_promise;
    } else {
        return send_email_post_promise.event_abstract_id_random;
    }
}

/* END: Utility: Email Related */

function resolved(result) {
    console.log('Resolved');
}

function rejected(result) {
    console.error(result);
}

const parse_params = (params) => {
    const keys = Object.keys(params);
    let options = '';

    keys.forEach((key) => {
        const isParamTypeObject = typeof params[key] === 'object';
        const isParamTypeArray = isParamTypeObject && (params[key].length >= 0);

        if (!isParamTypeObject) {
            let encoded_value = encodeURIComponent(params[key]);
            options += `${key}=${encoded_value}&`;
            // options += `${key}=${params[key]}&`;
        }

        if (isParamTypeObject && isParamTypeArray) {
            params[key].forEach((element) => {
                let encoded_value = encodeURIComponent(element);
                options += `${key}=${encoded_value}&`;
                // options += `${key}=${element}&`;
            });
        }
    });

    return options ? options.slice(0, -1) : options;
};


// export let test = async function test() {
//     console.log('Exported test function from API.');
// }

let obj = {};
obj.delete_object = delete_object;
obj.get_object = get_object;
obj.patch_object = patch_object;
obj.post_object = post_object;
obj.get_ae_obj_id_crud = get_ae_obj_id_crud;
obj.get_ae_obj_li_for_obj_id_crud = get_ae_obj_li_for_obj_id_crud;
obj.create_ae_obj_crud = create_ae_obj_crud;
obj.update_ae_obj_id_crud = update_ae_obj_id_crud;
obj.delete_ae_obj_id_crud = delete_ae_obj_id_crud;
obj.download_hosted_file = download_hosted_file;
obj.delete_hosted_file = delete_hosted_file;
obj.get_data_store_obj_w_code = get_data_store_obj_w_code;
obj.send_email = send_email;
// obj.test = test;
export let api = obj;
// module.exports = api;